//	[]-------------------------------------------------------[]
//	|			 Nume program : EULER1            |
//	|  - Rezolva ecuatia : dy/dt = -y prin metodele Euler     |
//	| implicita,explicita,pentru pasi de integrare definiti   |
//	| de utilizator;				          |
//	| - Pentru metoda implicita se introduce si eroarea       |
//	| de aproximatie admisa;                                  |
//	| - Intervalul de integrare este [0,4];			  |
//	| - Conditia initiala este y(0) = 5;			  |
//	| - Se afiseaza pentru cele 2 metode erorile pentru       |
//	| primul pas si erorile globale;			  |
//	| - Pentru metoda implicita se afiseaza si numarul de	  |
//	| iteratii efectuate pentru atingerea preciziei impuse    |
//	[]-------------------------------------------------------[]

function [newy,nimpl,iter]=euler_imp2 (y,h,a,b,nimpl,iter,err,ITMAX)
    j = 0;
    nimpl = nimpl + 1;
    newy = y;                                // y implicit 
    oldy = 10000; // ca sa intre in ciclu prima data 
    while (abs(oldy-newy)> err*abs(newy)) & (j<=ITMAX );
        oldy = newy;
        if (h <= -1/a)
            newy = y + h*(a*newy + b); //iteratie simpla
        else
            newy = oldy - (oldy -y + h*oldy)/h; //newton
        end
        j = j + 1;
        //pause;
    end
    if j > ITMAX
        printf("\n Rezolvarea neliniara a metodei implicite nu este convergenta (apel implicit nr %d, nr iteratii %d)",nimpl,j);
    end
    iter = iter + j;
endfunction

function [] =  calc_err (ye,yi,t,k,a,b,y0,iter,nimpl)
    i=1;

    epse = funcan (t,a,b,y0) - ye;
    epsi = funcan (t,a,b,y0) - yi;
    if (k==1)
        printf("\n \n Eroare locala:");
        printf ("\n     metoda explicita = % 10.4e",abs(epse));
        printf ("\n     metoda implicita = % 10.4e",abs(epsi));
    else
        printf("\n \n Eroare globala:");
        printf ("\n     metoda explicita = % 10.4e",abs(epse));
        printf ("\n     metoda implicita = % 10.4e",abs(epsi));
        printf ("\n     nr mediu de iteratii la metoda implicita = %d",int(iter/nimpl+.5));
    end
endfunction


function [Ee,Ei,timp] = solve2 (a,b,y0,h,tmax,iter,nimpl,err,ITMAX)
    t = 0;	                     // nod initiala 
    ye = y0;               	     // conditii initiale 
    yi = y0;
    Ee(1) = ye;
    Ei(1) = yi;
    timp(1) = 0;
    n = int(tmax/h+.5);              // nr. maxim de pasi 
    for  i = 1:n   // calcul 
        t =t + h;                 // nod nou
        timp = [timp; t];
        ye = euler_exp (ye,h,a,b);  // calcul Euler - explicit 
        Ee = [Ee;ye];
        [yi,nimpl,iter]=euler_imp2 (yi,h,a,b,nimpl,iter,err,ITMAX)
        Ei = [Ei;yi];
        if (i==1) 
            calc_err (ye,yi,t,i,a,b,y0,iter,nimpl);	// calcul eroare pas 1
        end
    end
    calc_err (ye,yi,t,n,a,b,y0,iter,nimpl);	  // calcul eroare globala 
endfunction


function [a,b,y0,h,tmax,err,nimpl,iter,ITMAX] = inputl18b()
    a = -1;
    b = 0;
    y0 = 1;
    h = [];
    tmax = [];
    initial = ['0.001','4','0.001','30'];
    txt = ['pas de integrare h','timp maxim de simulare tmax = ','eroare impusa pt metoda implicita','nr max de iteratii pt metoda implicita'];
    sig = x_mdialog(['Programul rezolva ecuatia : dy/dt = -y';...
    '                            y(0) = 1';...
    'Interval de integrare : t in [0,tmax] [s].'],txt,initial);
    if (sig <> [])
        h = evstr(sig(1));
        tmax = evstr(sig(2));
        err = evstr(sig(3));
        ITMAX = evstr(sig(4));
    else
        exec('mainL10.sci');
    end;
    nimpl = 0; // nr apelari euler_imp
    iter = 0;  // nr iteratii

    printf("\n ===================================");
    printf("\n ======== ANALIZA ERORI ============");
    printf("\n Pasul de integrare h = %e",h);
    printf("\n Timp maxim de simulare = %e",tmax);
    printf("\n Eroarea impusa pentru metoda implicita = %e",err);
    printf("\n Nr maxim de iteratii pentru metoda implicita = %e",ITMAX);
endfunction


